#include "StdAfx.h"
#include "FTImageMap.h"
//#include "UIElement.h"

//#define IMAGE_DIR   TEXT("filetransfer")
////--------------------------------------------
//#define ICON_PATH_BUBBLE_ETC	TEXT("filetransfer\\ic_talk_file_b_16.png")
//#define ICON_PATH_PLAIN_ETC		TEXT("filetransfer\\ic_talk_file_16.png")


//static WCHAR* pic_progress_bar[] = {
//L"img_talk_file_progress_bg_01.png",
//L"img_talk_file_progress_bar_01.png",
//L"img_talk_file_progress_bg_02.png",
//L"img_talk_file_progress_bar_02.png",
//L"img_talk_file_progress_bg_03.png",
//L"img_talk_file_progress_bar_03.png",
//L"btn_talk_file_cancle.png"
//};


#define FILE_EXT_DOC _T(".doc")
#define FILE_EXT_DOCX _T(".docx") 
#define FILE_EXT_XLS _T(".xls")
#define FILE_EXT_XLSX _T(".xlsx")
#define FILE_EXT_PPT _T(".ppt")
#define FILE_EXT_PPTX _T(".pptx") 
#define FILE_EXT_PDF _T(".pdf")
#define FILE_EXT_HWP _T(".hwp") 
#define FILE_EXT_AVI _T(".avi")
#define FILE_EXT_MOV _T(".mov")
#define FILE_EXT_MPG _T(".mpg")
#define FILE_EXT_MPEG _T(".mpeg")
#define FILE_EXT_MP3 _T(".mp3") 
#define FILE_EXT_WAV _T(".wav") 
#define FILE_EXT_JPG _T(".jpg") 
#define FILE_EXT_JPEG _T(".jpeg")
#define FILE_EXT_GIF _T(".gif") 
#define FILE_EXT_BMP _T(".bmp") 
#define FILE_EXT_TXT _T(".txt") 
#define FILE_EXT_ZIP _T(".zip") 


static TCHAR* pic_progress_bar[] = {
	_T("\\filetransfer\\img_talk_file_progress_bg.png"),
	_T("\\filetransfer\\img_talk_file_progress_bar.png"),
	_T("\\filetransfer\\btn_talk_file_cancle.png"),
	_T("\\filetransfer\\btn_talk_file_cancle.png")
};

static TCHAR* pic_slide_bar[] = {
	_T("\\slidecontrol_bar.png"),
	_T("\\slidecontrol_bar.png"),
	_T("\\slidecontrol_nob.png"),
};

static TCHAR* new_message_btn[] = {
	_T("\\btn_chat_talk_down_nor.png"),
	_T("\\btn_chat_talk_down_nor.png")
};

static TCHAR* FileSuffixIcons[] = {
	_T("\\filetransfer\\ic_talk_file_01.png"), 
	_T("\\filetransfer\\ic_talk_file_02.png"),
	_T("\\filetransfer\\ic_talk_file_03.png"),
	_T("\\filetransfer\\ic_talk_file_04.png"),
	_T("\\filetransfer\\ic_talk_file_05.png"),
	_T("\\filetransfer\\ic_talk_file_06.png"),
	_T("\\filetransfer\\ic_talk_file_07.png"),
	_T("\\filetransfer\\ic_talk_file_08.png"),
	_T("\\filetransfer\\ic_talk_file_09.png"),
	_T("\\filetransfer\\ic_talk_file_10.png"),
	_T("\\filetransfer\\ic_talk_file_11.png"),
	_T("\\filetransfer\\ic_talk_file_12.png"),
	_T("\\filetransfer\\ic_talk_file_13.png"),
	_T("\\filetransfer\\ic_talk_file_14.png"),
	_T("\\filetransfer\\ic_talk_file_15.png"),
	_T("\\filetransfer\\ic_talk_file_16.png")
};

static TCHAR* FileSuffixBubbleIcons[] = {
	_T("\\filetransfer\\ic_talk_file_b_01.png"),
	_T("\\filetransfer\\ic_talk_file_b_02.png"),
	_T("\\filetransfer\\ic_talk_file_b_03.png"),
	_T("\\filetransfer\\ic_talk_file_b_04.png"),
	_T("\\filetransfer\\ic_talk_file_b_05.png"),
	_T("\\filetransfer\\ic_talk_file_b_06.png"),
	_T("\\filetransfer\\ic_talk_file_b_07.png"),
	_T("\\filetransfer\\ic_talk_file_b_08.png"),
	_T("\\filetransfer\\ic_talk_file_b_09.png"),
	_T("\\filetransfer\\ic_talk_file_b_10.png"),
	_T("\\filetransfer\\ic_talk_file_b_11.png"),
	_T("\\filetransfer\\ic_talk_file_b_12.png"),
	_T("\\filetransfer\\ic_talk_file_b_13.png"),
	_T("\\filetransfer\\ic_talk_file_b_14.png"),
	_T("\\filetransfer\\ic_talk_file_b_15.png"),
	_T("\\filetransfer\\ic_talk_file_b_16.png")
};

//struct FILE_SUFFIX_2_ICON_INFO
//{
//	LPCTSTR pszFileSuffix;
//	LPCTSTR pszPlainIconPath;
//	LPCTSTR pszBubbleIconPath;
//};
//
//static const FILE_SUFFIX_2_ICON_INFO g_FileSuffixIcons[] = 
//{
//	{ _T(".doc"), _T("filetransfer\\ic_talk_file_01.png"), _T("filetransfer\\ic_talk_file_b_01.png") },
//	{ _T(".docx"), _T("filetransfer\\ic_talk_file_01.png"), _T("filetransfer\\ic_talk_file_b_01.png") },
//	{ _T(".xls"), _T("filetransfer\\ic_talk_file_02.png"), _T("filetransfer\\ic_talk_file_b_02.png") },
//	{ _T(".xlsx"), _T("filetransfer\\ic_talk_file_02.png"), _T("filetransfer\\ic_talk_file_b_02.png") },
//	{ _T(".ppt"), _T("filetransfer\\ic_talk_file_03.png"), _T("filetransfer\\ic_talk_file_b_03.png") },
//	{ _T(".pptx"), _T("filetransfer\\ic_talk_file_03.png"), _T("filetransfer\\ic_talk_file_b_03.png") },
//	{ _T(".pdf"), _T("filetransfer\\ic_talk_file_04.png"), _T("filetransfer\\ic_talk_file_b_04.png") },
//	{ _T(".hwp"), _T("filetransfer\\ic_talk_file_05.png"), _T("filetransfer\\ic_talk_file_b_05.png") },
//	{ _T(".avi"), _T("filetransfer\\ic_talk_file_06.png"), _T("filetransfer\\ic_talk_file_b_06.png") },
//	{ _T(".mov"), _T("filetransfer\\ic_talk_file_07.png"), _T("filetransfer\\ic_talk_file_b_07.png") },
//	{ _T(".mpg"), _T("filetransfer\\ic_talk_file_08.png"), _T("filetransfer\\ic_talk_file_b_08.png") },
//	{ _T(".mpeg"), _T("filetransfer\\ic_talk_file_08.png"), _T("filetransfer\\ic_talk_file_b_08.png") },
//	{ _T(".mp3"), _T("filetransfer\\ic_talk_file_09.png"), _T("filetransfer\\ic_talk_file_b_09.png") },
//	{ _T(".wav"), _T("filetransfer\\ic_talk_file_10.png"), _T("filetransfer\\ic_talk_file_b_10.png") },
//	{ _T(".jpg"), _T("filetransfer\\ic_talk_file_11.png"), _T("filetransfer\\ic_talk_file_b_11.png") },
//	{ _T(".jpeg"), _T("filetransfer\\ic_talk_file_11.png"), _T("filetransfer\\ic_talk_file_b_11.png") },
//	{ _T(".gif"), _T("filetransfer\\ic_talk_file_12.png"), _T("filetransfer\\ic_talk_file_b_12.png") },
//	{ _T(".bmp"), _T("filetransfer\\ic_talk_file_13.png"), _T("filetransfer\\ic_talk_file_b_13.png") },
//	{ _T(".txt"), _T("filetransfer\\ic_talk_file_14.png"), _T("filetransfer\\ic_talk_file_b_14.png") },
//	{ _T(".zip"), _T("filetransfer\\ic_talk_file_15.png"), _T("filetransfer\\ic_talk_file_b_15.png") }
//};
//
////--------------------------------------
//// implementation of CFTImageMap
////
//std::map<UINT, Image*>  CFTImageMap::map_id_imge;
//
//Image*  CFTImageMap::GetImage(UINT ResID)
//{
//	map<UINT, Image*>::const_iterator const_it;
//	const_it = map_id_imge.find(ResID);
//
//	if(const_it != map_id_imge.end())
//		return const_it->second;
//	else
//	{
//	if(ResID < 100 && map_id_imge.size() <= 8)
//	{
//			LoadProgressImage();
//	}
//	
//	const_it = map_id_imge.find(ResID);
//	if(const_it != map_id_imge.end())
//		return const_it->second;
//
//	ASSERT(FALSE);
//	//return GetFileTypeImage(ResID);
//	}
//	return NULL;
//}
//
//Image*  CFTImageMap::GetFileTypeImage(IUIElementResouce* pResource, LPCTSTR pszFilePath)
//{
//	ASSERT(pResource);
//	ASSERT(pszFilePath);
//	if (!pResource || !pszFilePath )
//	{
//		return NULL;
//	}
//
//	CString strFilePath(pszFilePath);
//	CString strIconPath; //default Icon Path
//	int nChatDisplayType = pResource->GetChatDisplayType();//GET_CONFIG()->GetChatDisplayType();
//	if (CHAT_BUBBLE == nChatDisplayType)
//	{
//		strIconPath = ICON_PATH_BUBBLE_ETC;
//	}
//	else
//	{
//		strIconPath = ICON_PATH_PLAIN_ETC;
//	}
//
//	int nDotPos = strFilePath.ReverseFind(_T('.'));// .find_last_of(L".");
//	
//	if(nDotPos >= 0)
//	{
//		CString strSuffix = strFilePath.Mid(nDotPos);
//		int nCount = _countof(g_FileSuffixIcons);
//		for (int nIndex = 0; nIndex < nCount; nIndex++)
//		{
//			if (strSuffix.CompareNoCase(g_FileSuffixIcons[nIndex].pszFileSuffix) == 0)
//			{
//				if (CHAT_BUBBLE == nChatDisplayType)
//				{
//					strIconPath = g_FileSuffixIcons[nIndex].pszBubbleIconPath;
//				}
//				else
//				{
//					strIconPath = g_FileSuffixIcons[nIndex].pszPlainIconPath;
//				}
//				break;
//			}
//		}
//	}
//	return pResource->GetCacheImageByFilePath(strIconPath);
//}
//
//
//
//void CFTImageMap::LoadProgressImage( )
//{
//	WCHAR ImgDir[MAX_PATH] = {0};
//	GetImageDir(ImgDir,MAX_PATH);
//	int num = sizeof(pic_progress_bar)/sizeof(pic_progress_bar[0]);
//	int index = 0;
//	for(; index < num; ++index)
//	{
//		WCHAR img[MAX_PATH] = {0};
//		StringCchPrintfW(img, MAX_PATH, L"%s/%s", ImgDir, pic_progress_bar[index]);
//		if(PathFileExistsW(img))
//		{
//			Bitmap *bitmap = Bitmap::FromFile(img);
//			if(bitmap)
//			{
//				pair<UINT, Image*> pr;
//				pr.first = index;
//				pr.second = bitmap;
//				map_id_imge.insert(pr);
//			}
//		}
//
//	}
//
//
//}
//
//LPWSTR CFTImageMap::GetImageDir(LPWSTR ImgDir, int len)
//{
//	ZeroMemory(ImgDir, len);
//	WCHAR ExeDir[MAX_PATH] = {0};
//	GetCurrentDirectoryW(MAX_PATH, ExeDir);
//	CString AppDir = GetAppImgDir();
//	StringCchPrintfW(ImgDir, MAX_PATH, L"%s/%s", AppDir.GetString(), IMAGE_DIR);
//	return ImgDir;
//}
//
//
///*
// * @memo:
// * 1: cleanup memory used by pictures. it should be finally invoked only time during the whole lifetime of application.
// */
//void CFTImageMap::ClearAll()
//{
//	if(CFTImageMap::map_id_imge.size() > 0)
//	{
//		map<UINT, Image*>::iterator it1, it_end;
//		it1  = CFTImageMap::map_id_imge.begin();
//		it_end = CFTImageMap::map_id_imge.end();
//		for(; it1 != it_end; ++it1)
//		{
//			Image* image = it1->second;
//			delete image;
//		}
//		map_id_imge.clear();
//	}
//		
//
//}

CFTImageMapInt::CFTImageMapInt()
{
	m_bLoad = FALSE;
}

CFTImageMapInt::~CFTImageMapInt()
{
	//_ClearImageResouce();
}

CFTImageMapInt* CFTImageMapInt::Instance()
{
	static CFTImageMapInt FTImageMapInt;
	return &FTImageMapInt;
}

Image* CFTImageMapInt::GetImageByID( int nImageIdx )
{
	Init();
	map<UINT, Image*>::const_iterator const_it;
	const_it = map_id_imge.find(nImageIdx);

	if(const_it != map_id_imge.end())
	{
		return const_it->second;
	}
	return NULL;
}

BOOL CFTImageMapInt::_LoadImageResouce()
{
	//progress bar
	CString strFilePath = GetAppImgDir();

	int num = sizeof(pic_progress_bar)/sizeof(pic_progress_bar[0]);
	for(int index = 0; index < num; ++index)
	{
		CString strImageFile = strFilePath + pic_progress_bar[index];
		if(PathFileExists(strImageFile))
		{
			Image *bitmap = new Image(strImageFile);
			if(bitmap)
			{
				pair<UINT, Image*> pr;
				pr.first = index + progress_bar_bg;
				pr.second = bitmap;
				map_id_imge.insert(pr);
			}
		}
	}

	//fileIcon
	num = sizeof(FileSuffixIcons) / sizeof(FileSuffixIcons[0]);
	for (int index = 0; index < num; index++)
	{
		CString strImageFile = strFilePath + FileSuffixIcons[index];
		if(PathFileExists(strImageFile))
		{
			Image *bitmap = new Image(strImageFile);
			if(bitmap)
			{
				pair<UINT, Image*> pr;
				pr.first = index + icon_doc;
				pr.second = bitmap;
				map_id_imge.insert(pr);
			}
		}
	}

	//fileIcon bubble
	num = sizeof(FileSuffixBubbleIcons) / sizeof(FileSuffixBubbleIcons[0]);
	for (int index = 0; index < num; index++)
	{
		CString strImageFile = strFilePath + FileSuffixBubbleIcons[index];
		if(PathFileExists(strImageFile))
		{
			Image *bitmap = new Image(strImageFile);
			if(bitmap)
			{
				pair<UINT, Image*> pr;
				pr.first = index + icon_doc_b;
				pr.second = bitmap;
				map_id_imge.insert(pr);
			}
		}
	}

	//slide bar
	num = sizeof(pic_slide_bar) / sizeof(pic_slide_bar[0]);
	for(int index = 0; index < num; index++)
	{
		CString strImageFile = strFilePath + pic_slide_bar[index];
		if(PathFileExists(strImageFile))
		{
			Image *bitmap = new Image(strImageFile);
			if(bitmap)
			{
				pair<UINT, Image*> pr;
				pr.first = index + slide_bar_bg;
				pr.second = bitmap;
				map_id_imge.insert(pr);
			}
		}
	}

	//newmessage_bg
	{
		CString strImageFile = strFilePath + _T("\\img_chat_talk_old_bg.png");
		if(PathFileExists(strImageFile))
		{
			Image *bitmap = new Image(strImageFile);
			if(bitmap)
			{
				pair<UINT, Image*> pr;
				pr.first = img_talk_newmessages_bg;
				pr.second = bitmap;
				map_id_imge.insert(pr);
			}
		}
	}

	//newmessage btn
	num = _countof(new_message_btn);
	for(int index = 0; index < num; index++)
	{
		CString strImageFile = strFilePath + new_message_btn[index];
		if(PathFileExists(strImageFile))
		{
			Image *bitmap = new Image(strImageFile);
			if(bitmap)
			{
				pair<UINT, Image*> pr;
				pr.first = index + img_talk_newmessages_btn;
				pr.second = bitmap;
				map_id_imge.insert(pr);
			}
		}
	}

	return TRUE;
}

void CFTImageMapInt::_ClearImageResouce()
{
	if(map_id_imge.size() > 0)
	{
		map<UINT, Image*>::iterator it1 = map_id_imge.begin();
		for(; it1 != map_id_imge.end(); ++it1)
		{
			Image* image = it1->second;
			delete image;
			it1->second = NULL;
		}
		map_id_imge.clear();
	}
	m_bLoad = FALSE;
}

int CFTImageMapInt::FindeImageIDByFileNameExt( CString strFileExt, BOOL bBubble )
{
	if (strFileExt.CompareNoCase(FILE_EXT_DOC) == 0 
		|| strFileExt.CompareNoCase(FILE_EXT_DOCX) == 0)
	{	
		if (bBubble)
		{
			return icon_doc_b;
		}
		return icon_doc;
	}
	else if (strFileExt.CompareNoCase(FILE_EXT_XLS) == 0 
		|| strFileExt.CompareNoCase(FILE_EXT_XLSX) == 0)
	{
		if (bBubble)
		{
			return icon_xls_b;
		}
		return icon_xls;
	}
	else if (strFileExt.CompareNoCase(FILE_EXT_PPT) == 0 
		|| strFileExt.CompareNoCase(FILE_EXT_PPTX) == 0)
	{
		if (bBubble)
		{
			return icon_ppt_b;
		}
		return icon_ppt;
	}
	else if (strFileExt.CompareNoCase(FILE_EXT_PDF) == 0)
	{
		if (bBubble)
		{
			return icon_pdf_b;
		}
		return icon_pdf;
	}
	else if (strFileExt.CompareNoCase(FILE_EXT_HWP) == 0)
	{
		if (bBubble)
		{
			return icon_hwp_b;
		}
		return icon_hwp;
	}
	else if (strFileExt.CompareNoCase(FILE_EXT_AVI) == 0)
	{
		if (bBubble)
		{
			return icon_avi_b;
		}
		return icon_avi;
	}
	else if (strFileExt.CompareNoCase(FILE_EXT_AVI) == 0)
	{
		if (bBubble)
		{
			return icon_avi_b;
		}
		return icon_avi;
	}
	else if (strFileExt.CompareNoCase(FILE_EXT_MOV) == 0)
	{
		if (bBubble)
		{
			return icon_mov_b;
		}
		return icon_mov;
	}
	else if (strFileExt.CompareNoCase(FILE_EXT_MPG) == 0 
		|| strFileExt.CompareNoCase(FILE_EXT_MPEG) == 0)
	{
		if (bBubble)
		{
			return icon_mpg_b;
		}
		return icon_mpg;
	}
	else if(strFileExt.CompareNoCase(FILE_EXT_MP3) == 0)
	{
		if (bBubble)
		{
			return icon_mp3_b;
		}
		return icon_mp3;
	}
	else if(strFileExt.CompareNoCase(FILE_EXT_WAV) == 0)
	{
		if (bBubble)
		{
			return icon_wav_b;
		}
		return icon_wav;
	}
	else if (strFileExt.CompareNoCase(FILE_EXT_JPG) == 0 
		|| strFileExt.CompareNoCase(FILE_EXT_JPEG) == 0)
	{
		if (bBubble)
		{
			return icon_jpg_b;
		}
		return icon_jpg;
	}
	else if(strFileExt.CompareNoCase(FILE_EXT_GIF) == 0)
	{
		if (bBubble)
		{
			return icon_gif_b;
		}
		return icon_gif;
	}
	else if(strFileExt.CompareNoCase(FILE_EXT_BMP) == 0)
	{
		if (bBubble)
		{
			return icon_bmp_b;
		}
		return icon_bmp;
	}
	else if(strFileExt.CompareNoCase(FILE_EXT_TXT) == 0)
	{
		if (bBubble)
		{
			return icon_txt_b;
		}
		return icon_txt;
	}
	else if(strFileExt.CompareNoCase(FILE_EXT_ZIP) == 0)
	{
		if (bBubble)
		{
			return icon_zip_b;
		}
		return icon_zip;
	}
	else
	{
		if (bBubble)
		{
			return icon_etc_b;
		}
		return icon_etc;
	}
}

void CFTImageMapInt::Release()
{
	_ClearImageResouce();
}

BOOL CFTImageMapInt::Init()
{
	if (!m_bLoad)
	{
		m_bLoad = _LoadImageResouce();
	}
	return m_bLoad;
}

